<!doctype html public "-//W3C//DTD HTML 4.0 Transitional //EN">
<html>
<head>
  <meta name="GENERATOR" content="mkd2html 2.1.8a DEBUG DL=DISCOUNT">
  <meta http-equiv="Content-Type"
        content="text/html; charset=utf-8">  <link rel="stylesheet"
        type="text/css"
        href="style.css" />
</head>
<body>
<p>Appunti Reti - &copy; 2017 Mario Cianciolo &lt;mr.udda@gmail.com&gt;</p>

<h1>Livello Data Link</h1>

<p>Lo strato Data Link ha la funzione di fornire servizi di trasmissione di flussi
di bit allo strato Network sovrastante.<br/>
I compiti principali del livello Data Link sono:</p>

<ul>
<li>raggruppare i bit dal livello fisico in modo da formare pacchetti (<strong>framing</strong>)</li>
<li>gestire l’<strong>accesso al mezzo fisico</strong>, nel caso di link broadcast (<em>sottolivello MAC</em>)</li>
<li>fornire un <strong>recapito affidabile</strong> (se richiesto dal tipo di servizio)</li>
<li>gestire gli <strong>errori</strong> dovuti al canale di trasmissione</li>
<li>regolare il <strong>flusso</strong> dei dati tra sorgente e destinazione</li>
</ul>


<p>Il protocollo di questo strato è, di solito, implementato negli adattatori alle
due estremità del link (es. scheda di rete).<br/>
Tipicamente i servizi offerti sono tre:</p>

<ul>
<li>servizio unacknowledged senza connessione</li>
<li>servizio acknowledged senza connessione</li>
<li>servizio acknowledged orientato alla connessione</li>
</ul>


<h2>Framing</h2>

<p>Per servire lo strato Network, lo strato Data Link deve a sua volta usare il servizio
fornito dallo strato fisico. Lo strato fisico non garantisce la consegna dei dati,
tale garanzia è invece compito dello strato Data Link.</p>

<p>L'approccio è quello di suddividere il flusso di bit in una serie discreta di
<strong>frame</strong>, e calcolare il <strong>checksum</strong> per ogni frame. All'arrivo il checksum viene
ricalcolato e se non corrisponde il frame viene scartato.</p>

<p>Non è possibile, a causa degli intrinsechi ritardi nella rete, fare affidamento
su intervalli temporali per separare i frame, sono quindi stati sviluppati diversi
metodi di framing.</p>

<p>Per aumentare la ridondanza, normalmente si usa il conteggio dei caratteri unito
a uno degli altri metodi, e al checksum.</p>

<h3>Conteggio dei caratteri</h3>

<p>Ogni frame è preceduto dal conteggio dei propri caratteri.</p>

<p><img src="03_framing_charcount.jpg" alt="Framing con conteggio dei caratteri" /></p>

<p>Il problema di questo metodo è che errori di trasmissione possono alterare il conteggio,
inoltre non si può nemmeno richiedere la ritrasmissione, non conoscendo i limiti del frame.</p>

<h3>Flag byte con byte stuffing</h3>

<p>Ogni frame è preceduto e seguito dal <strong>flag byte</strong>, un valore costante tra le implementazioni
di rete. In questo modo, quando il destinatario perde la sincronia, gli basta cercare
una sequenza di due byte <code>FLAG</code> (la fine di un frame e l'inizio del successivo).</p>

<p>Il <strong>byte stuffing</strong> consiste nel far precedere da un byte di <strong>escape</strong> (<code>ESC</code>)
un eventuale <code>FLAG</code> presente nel messaggio, in modo da distinguerlo dal footer del
frame. Due <code>ESC</code> in sequenza si usano per trasmettere un <code>ESC</code> nel messaggio.</p>

<p>Il principale svantaggio è quello di essere legato a codifiche di caratteri a 8 bit,
non universali.</p>

<h3>Flag di inizio e fine con bit stuffing</h3>

<p>Ogni frame inizia e finisce con <code>01111110</code> (flag byte). Ogni volta che si incontrano
cinque bit <code>1</code> consecutivi, viene inserito uno <code>0</code>, rimosso poi a destinazione.</p>

<p>Questo metodo è indipendente dalla codifica dei dati.</p>

<h3>Violazioni della codifica dello strato fisico</h3>

<p>Questo metodo si applica solo alle reti in cui la codifica contiene ridondanze a livello fisico.</p>

<p>Per esempio, in alcune LAN, ogni bit è rappresentato da una coppia di segnali: transizione basso-alto (1)
e transizione alto-basso (0). Si usano le sequenze alto-alto e/o basso-basso per delimitare i frame.</p>

<h2>Controllo degli errori</h2>

<p>Normalmente (servizi <em>acknowledged</em>) dopo l'invio di un frame si attende la risposta
del destinatario. Se la risposta è negativa il frame viene ritrasmesso.</p>

<p>Se la risposta non arriva (problema hardware) un <strong>timer</strong> del mittente fa ritrasmettere il frame.<br/>
Ogni frame è <strong>numerato</strong>, per evitare che venga passato due volte allo strato network doop una ritrasmissione.</p>

<p>In base alla natura del mezzo, gli errori possono essere singoli o a grappolo (<strong>burst</strong>).<br/>
Per far fronte agli errori, in ciascun blocco di dati vengono trasmesse delle informazioni ridondanti.</p>

<h3>Codifiche a correzione di errore</h3>

<p>Vengono inseriti abbastanza dati per poter correggere l'errore senza necessità di ritrasmissione.
Dette anche <em>forward error correction</em>.</p>

<p>Uso tipico: canali rumorosi (wireless) in cui anche la ritrasmissione potrebbe contenere errori,
rendendo molto difficile la comunicazione.</p>

<h4>Distanza di Hamming</h4>

<p>Consideriamo un frame composto da <code>m</code> bit di dati e <code>r</code> bit ridondanti per i controlli.
Chiamiamo <code>n</code> = <code>m</code> + <code>r</code> la lunghezza totale del frame.<br/>
Un'unità di n bit che contiene dati e bit di controllo viene chiamata <strong>codeword</strong> di n bit.</p>

<p>La <strong>distanza di Hamming</strong> tra due codeword è il numero di bit diversi nelle due sequenze.
Si calcola facilmente facendo lo <em>XOR</em> delle due codeword e contando i bit a 1.<br/>
Se due codeword hanno distanza <code>d</code>, saranno necessari <code>d</code> errori sui singoli bit per passare
da una sequenza all'altra.</p>

<p>Normalmente tutte le combinazioni di bit dati solo legali, ma aggiungendo i bit di controllo solo alcune codeword hanno significato in una data codifica.<br/>
La minima distanza di Hamming tra due codeword di una codifica è la distanza di Hamming dell'intera codifica.</p>

<h5>Correzione e rilevamento errori</h5>

<ul>
<li>per <strong>rilevare</strong> <code>d</code> errori è necessaria una codifica con distanza <code>d + 1</code></li>
<li>per <strong>correggere</strong> <code>d</code> errori è necessaria una codifica con distanza <code>2d + 1</code></li>
</ul>


<p>Motivazione (esempio per 1 errore): una codifica con distanza <code>2</code> suddivide l'insieme delle
possibili codeword in due gruppi di coppie a distanza 2. Ogni codeword illegale si troverà
al centro di una di queste coppie, e non si può sapere quale delle due fosse prima dell'errore.<br/>
Se la codifica ha distanza <code>3</code>, i due insiemi sono di coppie a distanza 3, e qualsiasi codeword
illegale sarà più vicina ad una o all'altra codeword lecita, permettendo di correggere l'errore.</p>

<p>Da questa spiegazione si deduce che la correzione degli errori si effettua
esclusivamente su base <strong>probabilistica</strong>, ovvero si fa coincidere la codeword
errata con la codeword legale più &ldquo;vicina&rdquo;.</p>

<h4>Bit di parità</h4>

<p>Aggiungere un bit di parità ad un messaggio è una semplice codifica con distanza di Hamming pari a 2,
che può essere usata per rilevare errori su singoli bit.</p>

<h4>Codifica di Hamming</h4>

<p>Per correggere tutti gli errori singoli, una codifica con <code>m</code> bit di dati e <code>r</code> bit di
controllo (totale <code>n</code> bit) deve soddisfare la seguente relazione (valida solo per distanza 3):</p>

<pre>m + 1 &leq; 2<sup>r</sup> - r</pre>


<p>Questa disequazione pone un limite inferiore al numero di bit di controllo necessari
per una codifica a distanza 3 (in grado di correggere errori singoli).<br/>
Risolvendo per <code>r</code>, ricaviamo i bit di ridondanza che servono per correggere
errori singoli in codeword di <code>m</code> bit.</p>

<p>Esiste una codifica che raggiunge questo limite: la <strong>codifica di Hamming</strong>.
L'algoritmo è il seguente:</p>

<ul>
<li>numerare i bit da sinistra a partire da 1 (non da 0)</li>
<li>tutti i bit potenze di 2 (1, 2, 4, 8, 16, &hellip;) sono bit di controllo, gli altri sono bit dati</li>
<li>prendere nota delle posizioni dei bit dati (dopo che sono stati inseriti i bit di controllo) e trascriverle in binario (es. il bit 3 diventa il bit 6 -> 110)</li>
<li>ogni bit di controllo sarà un bit di parità per tutti i bit dati in posizione opportuna (es. il bit 6 -> 110 influenzerà la parità dei bit 2 e 4)</li>
</ul>


<p>Alla ricezione di un messaggio in codifica di Hamming, vengono ricontrollate le parità secondo lo stesso schema.
La somma delle posizioni delle parità errate darà la posizione del bit invertito (es. se sono sbagliate le parità dei bit 1, 4, 8 allora il bit invertito è il 13).</p>

<h5>Codifica di Hamming per errori burst (due dimensioni)</h5>

<p>Con un piccolo trucco si può usare la codifica di Hamming per correggere errori burst.</p>

<p>Una sequenza di <code>k</code> codeword è disposta riga per riga in modo da formare una matrice.
I dati vengono poi spediti in colonne invece che riga per riga. In questo modo un
burst di lunghezza <code>k</code> cambierà al massimo un bit per riga, e la codifica di Hamming
riuscirà a correggerlo.</p>

<p>Questo metodo utilizza <code>k * r</code> bit di controllo per rendere immuni <code>k * m</code> bit di dati
da errori burst di lunghezza massima <code>k</code>.</p>

<h5>Dimostrazione della disequazione della ridondanza</h5>

<p>Per ognuno dei 2<sup>m</sup> messaggi legali esistono <code>n</code> codeword illegali a distanza 1,
ottenute invertendo un singolo bit della codeword legale, per un totale di (n + 1)
combinazioni dedicate ad ogni messaggio legale.</p>

<p>Visto che il numero totale di codeword è 2<sup>n</sup>, dovremo avere: (n + 1) 2<sup>m</sup> &leq; 2<sup>n</sup><br/>
Sostituendo n = m + r, si ottiene la disequazione finale.</p>

<p>Se dovessimo correggere errori doppi (distanza 5) le combinazioni dedicate sarebbero
il messaggio (1) + le codeword a distanza 1 (n) + le codeword a distanza 2 (n * (n + 1)).
Dopodiché si procede come sopra.<br/>
Lo stesso vale per codifiche di distanza superiore.</p>

<h3>Codifiche a rilevazione di errore</h3>

<p>Vengono inseriti abbastanza dati per poter rilevare un errore, e richiedere la ritrasmissione.</p>

<p>Uso tipico: canali affidabili (cavi, fibra)</p>

<h4>Parità a due dimensioni</h4>

<p>Se aggiungiamo ai blocchi dati un singolo bit di parità, errori burst saranno rilevati
con probabilità del 50%, inaccettabile.</p>

<p>La soluzione è considerare il blocco dati come una matrice rettangolare <code>n</code>x<code>k</code>, e
calcolare un bit di parità per ogni riga e uno per ogni colonna, e trasmettere
il tutto sequenzialmente.<br/>
Se anche uno solo dei bit di parità è errato, il blocco dati è scartato.<br/>
Tuttavia, questo metodo può <strong>correggere</strong> singoli errori sui bit.</p>

<p><img src="02_parita_2d.jpg" alt="Parità a due dimensioni" /></p>

<p>Questo metodo riesce a rilevare errori burst di lunghezza <code>n</code>, perché in tal caso viene
alterato un solo bit per colonna.<br/>
Errori burst di lunghezza <code>n + 1</code> potrebbero passare inosservati (si considera errore
burst anche se solo il primo e l'ultimo bit sono alterati).</p>

<p>La probabilità che ognuna delle <code>n</code> colonne abbia casualmente un valore corretto di
parità è del 50%, quindi la probabilità che un blocco in errore venga accettato è
pari a 2<sup>-n</sup>.</p>

<h4>CRC (Codifica polinomiale)</h4>

<p>Le codifiche a rilevamento di errore sono utilizzate nei canali con basso livello
di rumore, nei quali è più conveniente richiedere un nuovo invio di un frame
danneggiato piuttosto che tentare di correggere gli errori.</p>

<p>Nella <strong>codifica polinomiale</strong>, o <strong>CRC</strong> (<em>Cyclic Redundancy Check</em>), si trattano
le sequenze di bit come coefficienti di polinomi.<br/>
Un frame di lunghezza <code>k</code> è visto come un polinomio di grado <code>k - 1</code>.
Il termine di grado <code>n</code> è presente solo se il bit in posizione <code>n</code> vale <code>1</code>.</p>

<p>Ad esempio, la sequenza <code>110001</code> equivale al polinomio x<sup>5</sup> + x<sup>4</sup> + x<sup>0</sup></p>

<h5>Aritmetica</h5>

<p>L'aritmetica del CRC è a modulo 2:</p>

<ul>
<li>addizioni e sottrazioni sono equivalenti allo <strong>XOR</strong> (quindi senza riporti e prestiti)</li>
<li>le divisioni vengono eseguire in binario, eccetto che le sottrazioni sono a modulo 2</li>
<li>il dividendo <em>sta</em> nel divisore se hanno lo stesso numero di bit</li>
</ul>


<h5>Polinomio generatore</h5>

<p>Sorgente e destinatario devono accordarsi sulla scelta di un <strong>polinomio generatore</strong> G(x),
una sequenza di bit che inizia e termina con <code>1</code>.</p>

<h5>Calcolo del checksum</h5>

<p>Per poter calcolare il checksum di un frame di <code>m</code> bit, che corrisponde al polinomio M(x),
il frame deve essere più lungo del polinomio generatore.</p>

<p>Il meccanismo alla base del CRC consiste nell'aggiungere alla fine del frame un <strong>checksum</strong> tale che,
il polinomio rappresentato dal frame con checksum sia divisibile per G(x).</p>

<p>L'algoritmo per calcolare il checksum è il seguente:</p>

<ol>
<li>detta <code>r</code> la lunghezza del polinomio generatore, aggiungere <code>r</code> bit <code>0</code> alla fine del frame.
Il frame ora corrisponde al polinomio <strong>T(x) = x<sup>r</sup> M(x)</strong></li>
<li>dividere <strong>T(x)</strong> per <strong>G(x)</strong></li>
<li>sottrarre (XOR) da <strong>T(x)</strong> il resto della divisione (che conterrà al massimo <code>r</code> bit). Il risultato è il frame con checksum</li>
</ol>


<p>Quando la destinazione riceve il frame T(x), prova a dividerlo per G(x). Un eventuale
resto indica un errore di trasmissione.</p>

<p>Il polinomio generatore di IEEE 802 è una precisa sequenza di 33 bit, che ha alcune proprietà utili:
rileva tutti i burst di errori di lunghezza uguale o minore a 32 e tutti quelli che toccano un numero dispari di bit</p>
</body>
</html>
